REM
REM  Few functions related to numeral conversions
REM  This file is part of the ZilogBoy project
REM  Copyright (C) Mateusz Viste 2010
REM

FUNCTION UbyteToByte(BYREF UnsignedByte AS UBYTE) AS BYTE
  REM Returns a signed value from a two-complemented integer
  IF UnsignedByte > &b01111111 THEN
      RETURN -1 - (UnsignedByte XOR &b11111111)
    ELSE
      RETURN UnsignedByte
  END IF
END FUNCTION

REM  a #DEFINE is much faster than a FUNCTION
#DEFINE DwordVal(FirstByte, SecondByte) ((SecondByte SHL 8) OR FirstByte)
'FUNCTION DwordVal(BYREF FirstByte AS UBYTE, BYREF SecondByte AS UBYTE) AS UINTEGER
'  REM Get the value of a DWORD (2 bytes -- 16bit unsigned value)
'  RETURN (SecondByte SHL 8) OR FirstByte
'END FUNCTION
